<?php

namespace Intergo\UserCallbackClient\Services;

use Illuminate\Support\Facades\Cache;
use Intergo\UserCallbackClient\Enums\UserCallbackEnum;
use Psr\SimpleCache\InvalidArgumentException;

class UserCallbackCountService
{
    /**
     * @param $userId
     * @return string
     */
    public static function key($userId)
    {
        return "Users:user_id_remote:$userId:callbacks_count";
    }

    public static function reduce($userId)
    {
        Cache::store(UserCallbackEnum::CALLBACKS_STORE)->decrement(self::key($userId));
    }

    /**
     * @param $userId
     * @return void
     */
    public static function increment($userId)
    {
        Cache::store(UserCallbackEnum::CALLBACKS_STORE)->increment(self::key($userId));
    }

    /**
     * @param $userId
     * @return mixed
     * @throws InvalidArgumentException
     */
    public static function get($userId) {
        return Cache::store(UserCallbackEnum::CALLBACKS_STORE)->get(self::key($userId));
    }
}
